const gulp = require('gulp'),
  concat = require('gulp-concat'),
  // uglify = require('gulp-uglify'),
  uglify = require('gulp-uglify-es').default,
  rename = require('gulp-rename'),
  jshint = require('gulp-jshint'),
  stripDebug = require("gulp-strip-debug"),//移除console语句
  cleanCSS = require('gulp-clean-css'),
  gutil = require('gulp-util'),
  browserify = require('gulp-browserify'),
  javascriptObfuscator = require('gulp-javascript-obfuscator');

const obfuscatorOptions = {
  compact:true,
  sourceMap: false,
  debugProtection: false,
  disableConsoleOutput: false
};

//处理fc的css
gulp.task('distfccss', function() {
  return gulp.src(['fc/css/**/*.css'])
    .pipe(cleanCSS())
    .pipe(gulp.dest('dist/fc/css'));
})
//处理fc的图片资源
gulp.task('distfcstatic', function() {
  return gulp.src(['fc/images/**/*'])
    .pipe(gulp.dest('dist/fc/images'));
})
gulp.task('distfcresource', function() {
  return gulp.src(['fc/resources/**/*'])
    .pipe(gulp.dest('dist/fc/resources'));
})
gulp.task('distfcjs', function() {
  return gulp.src(['fc/js/**/*.js', '!fc/js/nes-worker.js'])
    .pipe(javascriptObfuscator(obfuscatorOptions))
    .pipe(concat('main.min.js'))
    .pipe(gulp.dest('dist/fc/js'));
});

gulp.task('distotherjs', function() {
  return gulp.src(['fc/js/nes-worker.js'])
    .pipe(javascriptObfuscator(obfuscatorOptions))
    .pipe(gulp.dest('dist/fc/js'));
});


gulp.task('distlib', function () {
  return gulp.src('fc/source/index.js')
    .pipe(browserify({
      insertGlobals : false,
      debug: false,
      standalone: 'jsnes'
    }))
    .pipe(javascriptObfuscator(obfuscatorOptions))
    .pipe(rename('jsnes.min.js'))
    .pipe(gulp.dest('dist/fc/js/'));
});
gulp.task('distfc', ['distfcjs', 'distfccss', 'distfcstatic', 'distlib', 'distfcresource', 'distotherjs'])

module.exports = {
  dep: ['distfc'],
};

